/*
    appwizard.h
    Copyright (C) 2000  Kh. Naba Kumar Singh

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _APP_WIZARD_H_
#define _APP_WIZARD_H_

#include "project_dbase.h"
typedef struct _AppWizardGui AppWizardGui;
typedef struct _AppWizard AppWizard;

struct _AppWizardGui
{
	GtkWidget *window;
	GtkWidget *druid;
	GtkWidget *page[6];

	GtkWidget *icon_list;
	GtkWidget *target_type_entry;
	
	GtkWidget *prj_name_entry;
	GtkWidget *author_entry;
	GtkWidget *version_entry;
	GtkWidget *target_entry;
	
	GtkWidget *platform_89_check;
	GtkWidget *platform_92p_check;
	GtkWidget *platform_v200_check;
	GtkWidget *min_AMS_version_spinbutton;
	GtkWidget *return_err_to_AMS_check;
	GtkWidget *optimize_ROM_calls_check;
	GtkWidget *save_restore_LCD_check;
	
	GtkWidget *description_text;
	GtkWidget *target_exec_radio;
	GtkWidget *target_slib_radio;
	GtkWidget *target_dlib_radio;
	
	GtkWidget *file_header_check;

	GtkWidget *doors_frame;
	GtkWidget *doors_comment_entry;
	
	GtkWidget *dll_frame;
	GtkWidget *dll_id_spinbutton;
	GtkWidget *dll_major_version_spinbutton;
	GtkWidget *dll_minor_version_spinbutton;
	
};

struct _AppWizard
{
	AppWizardGui widgets;
	gint cur_page;

	gint  prj_type;
	gint  target_type;
	
	gchar *prj_name;
	gchar *target;
	gchar *author;
	gchar *version;

	gboolean platform_89_support;
	gboolean platform_92p_support;
	gboolean platform_v200_support;
	gboolean return_err_to_AMS;
	gboolean optimize_ROM_calls;
	gboolean save_restore_LCD;
	
	gchar *minAMS;
	gchar *description;

	gchar *doors_comment;

	gchar *dll_id;
	gchar *dll_major_version;
	gchar *dll_minor_version;

	gboolean use_header;
};

AppWizard *app_wizard_new (void);
void app_wizard_proceed (void);
void app_wizard_destroy (AppWizard * aw);

/* Private */
void create_app_wizard_gui (AppWizard * aw);
void create_app_wizard_page1 (AppWizard * aw);
void create_app_wizard_page2 (AppWizard * aw);
void create_app_wizard_page3 (AppWizard * aw);
void create_app_wizard_page4 (AppWizard * aw);

#endif
