/* 
    main_menubar_def.h
    Copyright (C) 2000  Kh. Naba Kumar Singh

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _MAIN_MENUBAR_DEF_H_
#define _MAIN_MENUBAR_DEF_H_

#include <gnome.h>
#include "lexer.h"
#include "print-doc.h"

#define NUM_FILE_SUBMENUS 27
static GnomeUIInfo file1_menu_uiinfo[NUM_FILE_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("_New"),
	 N_("New file"),
	 on_new_file1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_NEW,
	 GDK_N, GDK_CONTROL_MASK, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("_Open ..."),
	 N_("Open file"),
	 on_open1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_OPEN,
	 GDK_O, GDK_CONTROL_MASK, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("_Save"),
	 N_("Save current file"),
	 on_save1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SAVE,
	 GDK_S, GDK_CONTROL_MASK, NULL},
	{/*3*/
	 GNOME_APP_UI_ITEM, N_("Save _As ..."),
	 N_("Save the current file with a different name"),
	 on_save_as1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SAVE_AS,
	 0, 0, NULL},
	{/*4*/
	 GNOME_APP_UI_ITEM, N_("Save A_ll"),
	 N_("Save all currently open files, except new files"),
	 on_save_all1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SAVE,
	 0, 0, NULL},
	{/*5*/
	 GNOME_APP_UI_ITEM, N_("_Close File"),
	 N_("Close current file"),
	 on_close_file1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CLOSE,
	 GDK_W, GDK_CONTROL_MASK, NULL},
	{/*6*/
	 GNOME_APP_UI_ITEM, N_("Close All Files"),
	 N_("Close all files"),
	 on_close_all_file1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CLOSE,
	 GDK_D, GDK_MOD1_MASK, NULL},
	{/*7*/
	 GNOME_APP_UI_ITEM, N_("Reload F_ile"),
	 N_("Reload current file"),
	 on_reload_file1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_REVERT,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*8*/
	{/*9*/
	 GNOME_APP_UI_ITEM, N_("N_ew Project ..."),
	 N_("Create a Project using the Application Wizard"),
	 on_new_project1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_NEW,
	 0, 0, NULL},
	{/*10*/
	 GNOME_APP_UI_ITEM, N_("Open P_roject ..."),
	 N_("Open a Project"),
	 on_open_project1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_OPEN,
	 GDK_J, GDK_CONTROL_MASK, NULL},
	{/*11*/
	 GNOME_APP_UI_ITEM, N_("Sa_ve Project"),
	 N_("Save the current Project"),
	 on_save_project1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SAVE,
	 0, 0, NULL},
	{/*12*/
	 GNOME_APP_UI_ITEM, N_("Close Pro_ject"),
	 N_("Close the current Project"),
	 on_close_project1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CLOSE,
	 0, 0, NULL},
	{/*13*/
	 GNOME_APP_UI_ITEM, N_("Import TPR project"),
	 N_("Import a TPR project"),
	 on_import_TPR_project_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CONVERT,
	 0, 0, NULL},
	{/*14*/
	 GNOME_APP_UI_ITEM, N_("Export TPR project"),
	 N_("Export to a TPR project"),
	 on_export_TPR_project_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_JUMP_TO,
	 0, 0, NULL},
	 
	GNOMEUIINFO_SEPARATOR,/*15*/
	{/*16*/
	 GNOME_APP_UI_ITEM, N_("Rena_me ..."),
	 N_("Rename the current file"),
	 on_rename1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*17*/
	{/*18*/
	 GNOME_APP_UI_ITEM, N_("Page Set_up ..."),
	 N_("Page setup for printing"),
	 on_page_setup1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*19*/
	 GNOME_APP_UI_ITEM, N_("_Print"),
	 N_("Print the current file"),
	 anjuta_print_cb, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PRINT,
	 GDK_P, GDK_MOD1_MASK, NULL},
	{/*20*/
	 GNOME_APP_UI_ITEM, N_("_Print Preview"),
	 N_("Print preview of the current file"),
	 anjuta_print_preview_cb, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR, /*21*/
	{/*22*/
	 GNOME_APP_UI_ITEM, N_("Recent _Files"),
	 NULL,
	 NULL, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*23*/
	 GNOME_APP_UI_ITEM, N_("Recent Projec_ts"),
	 NULL,
	 NULL, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*24*/
	GNOMEUIINFO_MENU_EXIT_ITEM (on_exit1_activate, NULL),/*25*/
	GNOMEUIINFO_END/*26*/
};

# define NUM_TRANSFORM_SUBMENUS 7
static GnomeUIInfo transform1_submenu_uiinfo[NUM_TRANSFORM_SUBMENUS+1] = {
	{
	 /* 0 */
	 GNOME_APP_UI_ITEM, N_("_Make Selection Uppercase"),
	 N_("Make the selected text uppercase"),
	 on_editor_command_activate, (gpointer) ANE_UPRCASE, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 1 */
	 GNOME_APP_UI_ITEM, N_("Make Selection Lowercase"),
	 N_("Make the selected text lowercase"),
	 on_editor_command_activate, (gpointer) ANE_LWRCASE, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	 /* 2 */
	 GNOMEUIINFO_SEPARATOR,
	{
	 /* 3 */
	 GNOME_APP_UI_ITEM, N_("Convert EOL chars to CRLF"),
	 N_("Convert End Of Line characters to DOS EOL (CRLF)"),
	 on_transform_eolchars1_activate, GUINT_TO_POINTER (ANE_EOL_CRLF), NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 4 */
	 GNOME_APP_UI_ITEM, N_("Convert EOL chars to LF"),
	 N_("Convert End Of Line characters to Unix EOL (LF)"),
	 on_transform_eolchars1_activate, GUINT_TO_POINTER (ANE_EOL_LF), NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 5 */
	 GNOME_APP_UI_ITEM, N_("Convert EOL chars to CR"),
	 N_("Convert End Of Line characters to Mac OS EOL (CR)"),
	 on_transform_eolchars1_activate, GUINT_TO_POINTER (ANE_EOL_CR), NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 6 */
	 GNOME_APP_UI_ITEM, N_("Convert EOL chars to majority EOL"),
	 N_("Convert End Of Line characters to majority of the EOL found in the file"),
	 on_transform_eolchars1_activate, GUINT_TO_POINTER (0), NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	 /* 7 */
	GNOMEUIINFO_END
};

#define NUM_SELECT_SUBMENUS 4
static GnomeUIInfo select1_submenu_uiinfo[NUM_SELECT_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("_Select All"),
	 N_("Select all text in the editor"),
	 on_editor_command_activate, (gpointer) ANE_SELECTALL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_A, GDK_CONTROL_MASK, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("Select to _Brace"),
	 N_("Select the text in the matching braces"),
	 on_editor_command_activate, (gpointer) ANE_SELECTTOBRACE, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("Select Code Block"),
	 N_("Select the current code block"),
	 on_editor_command_activate, (gpointer) ANE_SELECTBLOCK, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_B, GDK_MOD1_MASK, NULL},
	{/*3*/
	 GNOME_APP_UI_ITEM, N_("Current Function"),
	 N_("Select the current function"),
	 on_editor_select_function , NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_END/*4*/
};

#define NUM_INSERTTEXT_SUBMENUS 7
static GnomeUIInfo inserttext1_submenu_uiinfo[NUM_INSERTTEXT_SUBMENUS+1] = {
       {/*0*/
        GNOME_APP_UI_ITEM, N_("/* GPL Notice */"),
        N_("Insert GPL notice with C style comments"),
        on_insert_c_gpl_notice, NULL, NULL,
        GNOME_APP_PIXMAP_NONE, NULL,
        0, 0, NULL},
       {/*1*/
        GNOME_APP_UI_ITEM, N_("// GPL Notice"),
        N_("Insert GPL notice with C++ style comments"),
        on_insert_cpp_gpl_notice, NULL, NULL,
        GNOME_APP_PIXMAP_NONE, NULL,
        0, 0, NULL},
	   {/*2*/
		GNOME_APP_UI_ITEM, N_("# GPL Notice"),
		N_("Insert GPL notice with Python style comments"),
		on_insert_py_gpl_notice, NULL, NULL,
		GNOME_APP_PIXMAP_NONE, NULL,
		0, 0, NULL},
	   {/*3*/
		GNOME_APP_UI_ITEM, N_("Current Username"),
		N_("Insert name of current user"),
		on_insert_username, NULL, NULL,
		GNOME_APP_PIXMAP_NONE, NULL,
		0, 0, NULL},
       {/*4*/
        GNOME_APP_UI_ITEM, N_("Current Date & Time"),
        N_("Insert current date & time"),
        on_insert_date_time, NULL, NULL,
        GNOME_APP_PIXMAP_NONE, NULL,
        0, 0, NULL},
       {/*5*/
        GNOME_APP_UI_ITEM, N_("Header File Template"),
        N_("Insert a standard header file template"),
        on_insert_header_template, NULL, NULL,
        GNOME_APP_PIXMAP_NONE, NULL,
        0, 0, NULL},
		{/*6*/
		GNOME_APP_UI_ITEM, N_("ChangeLog entry"),
        N_("Insert a ChangeLog entry"),
        on_insert_changelog_entry, NULL, NULL,
        GNOME_APP_PIXMAP_NONE, NULL,
        0, 0, NULL},
        GNOMEUIINFO_END/*7*/
};

#define NUM_TEMPLATE_C_SUBMENUS 4
static GnomeUIInfo insert_template_c_uiinfo[NUM_TEMPLATE_C_SUBMENUS+1] = {
    {/*0*/
    GNOME_APP_UI_ITEM, "switch",
    N_("Insert a switch template"),
    on_insert_switch_template, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, 0, NULL},
    {/*1*/
    GNOME_APP_UI_ITEM, "for",
    N_("Insert a for template"),
    on_insert_for_template, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, 0, NULL},
	{/*2*/
	GNOME_APP_UI_ITEM, "while",
	N_("Insert a while template"),
	on_insert_while_template, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	0, 0, NULL},
	{/*3*/
	GNOME_APP_UI_ITEM, "if...else",
	N_("Insert an if...else template"),
	on_insert_ifelse_template, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	0, 0, NULL},
   	GNOMEUIINFO_END/*4*/
};

#define NUM_CVSKEYWORD_SUBMENUS 8
static GnomeUIInfo insert_cvskeyword_submenu_uiinfo[NUM_CVSKEYWORD_SUBMENUS+1] = {
    {/*0*/
    GNOME_APP_UI_ITEM, "Author",
    N_("Insert the CVS Author keyword (author of the change)"),
    on_insert_cvs_author, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, 0, NULL},
    {/*1*/
    GNOME_APP_UI_ITEM, "Date",
    N_("Insert the CVS Date keyword (date and time of the change)"),
    on_insert_cvs_date, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, 0, NULL},
	{/*2*/
	GNOME_APP_UI_ITEM, "Header",
	N_("Insert the CVS Header keyword (full path, revision, date, author, state)"),
	on_insert_cvs_header, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	0, 0, NULL},
	{/*3*/
	GNOME_APP_UI_ITEM, "Id",
	N_("Insert the CVS Id keyword (file, revision, date, author)"),
	on_insert_cvs_id, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	0, 0, NULL},
	{/*4*/
	GNOME_APP_UI_ITEM, "Log",
	N_("Insert the CVS Log keyword (log message)"),
	on_insert_cvs_log, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	0, 0, NULL},
	{/*5*/
	GNOME_APP_UI_ITEM, "Name",
	N_("Insert the CVS Name keyword (name of the sticky tag)"),
	on_insert_cvs_name, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	0, 0, NULL},
	{/*6*/
	GNOME_APP_UI_ITEM, "Revision",
	N_("Insert the CVS Revision keyword (revision number)"),
	on_insert_cvs_revision, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	0, 0, NULL},
	{/*7*/
	GNOME_APP_UI_ITEM, "Source",
	N_("Insert the CVS Source keyword (full path)"),
	on_insert_cvs_source, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	0, 0, NULL},
   	GNOMEUIINFO_END/*8*/
};

#define NUM_INSERT_SUBMENUS 4
static GnomeUIInfo insert_submenu_uiinfo[NUM_INSERT_SUBMENUS+1] = {
    {/*0*/
    GNOME_APP_UI_ITEM, N_("Header"),
    N_("Insert a file header"),
    on_insert_header, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, 0, NULL},
	  {/*1*/
		GNOME_APP_UI_SUBTREE, N_("C template"),
		N_("Insert a C template"),
		insert_template_c_uiinfo, NULL, NULL,
		GNOME_APP_PIXMAP_NONE, NULL,
		0, 0, NULL},
	  {/*2*/
		GNOME_APP_UI_SUBTREE, N_("CVS keyword"),
		NULL,
		insert_cvskeyword_submenu_uiinfo, NULL, NULL,
		GNOME_APP_PIXMAP_NONE, NULL,
		0, 0, NULL},
	  {/*3*/
		GNOME_APP_UI_SUBTREE, N_("General"),
		NULL,
		inserttext1_submenu_uiinfo, NULL, NULL,
		GNOME_APP_PIXMAP_NONE, NULL,
		0, 0, NULL},
    GNOMEUIINFO_END/*4*/
};

#define NUM_COMMENT_SUBMENUS 3
static GnomeUIInfo comment_submenu_uiinfo[NUM_COMMENT_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("Block Comment/Uncomment"),
	 N_("Block comment the selected text"),
	 on_comment_block, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("Box Comment/Uncomment"),
	 N_("Box comment the selected text"),
	 on_comment_box, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("Stream Comment/Uncomment"),
	 N_("Stream comment the selected text"),
	 on_comment_stream, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_END/*10*/
};

#define NUM_FIND_SUBMENUS 6
static GnomeUIInfo find_submenu_uiinfo[NUM_FIND_SUBMENUS+1] = {
	{/*0*/
	GNOME_APP_UI_ITEM, N_("_Find ..."),
	N_("Search for a string or regular expression in the editor"),
	on_find1_activate, NULL, NULL,
	GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SEARCH,
	GDK_F, GDK_CONTROL_MASK, NULL},
	{/*1*/
	GNOME_APP_UI_ITEM, N_("Find _Next"),
	N_("Repeat the last Find command"),
	on_findnext1_activate, NULL, NULL,
	GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SEARCH,
	GDK_F6, GDK_SHIFT_MASK, NULL},
	{/*2*/
	GNOME_APP_UI_ITEM, N_("Find and R_eplace ..."),
	N_("Search for and replace a string or regular expression with another string"),
	on_find_and_replace1_activate, NULL, NULL,
	GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SRCHRPL,
	GDK_F, GDK_CONTROL_MASK | GDK_SHIFT_MASK, NULL},
	{/*3*/
	GNOME_APP_UI_ITEM, N_("Fin_d in Files ..."),
	N_("Search for a string in multiple files or directories"),
	on_find_in_files1_activate, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	0, 0, NULL},
	{/*4*/
	GNOME_APP_UI_ITEM, N_("_Enter Selection/I-Search"),
	N_("Enter the selected text as the search target"),
	on_enterselection, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	GDK_E, GDK_CONTROL_MASK, NULL},
	 {/*5*/
	 GNOME_APP_UI_ITEM, N_("Advanced Search/Replace"),
	 N_("Advanced Search And Replace stuff"),
	 anjuta_search_replace_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_END/*6*/
};

#define NUM_GOTO_SUBMENUS 12
static GnomeUIInfo goto1_submenu_uiinfo[NUM_GOTO_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("_Goto Line number ..."),
	 N_("Go to a particular line in the editor"),
	 on_goto_line_no1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_G, GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("Goto Matching _Brace"),
	 N_("Go to the matching brace in the editor"),
	 on_editor_command_activate, (gpointer) ANE_MATCHBRACE, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_M, GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("_Goto start of block"),
	 N_("Go to the start of the current block"),
	 on_goto_block_start1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_S, GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL},
	{/*3*/
	 GNOME_APP_UI_ITEM, N_("_Goto end of block"),
	 N_("Go to the end of the current block"),
	 on_goto_block_end1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_E, GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL},
	{/*4*/
	 GNOME_APP_UI_ITEM, N_("_Goto previous mesg"),
	 N_("Go to previous message"),
	 on_goto_prev_mesg1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_P, GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL},
	{/*5*/
	 GNOME_APP_UI_ITEM, N_("_Goto next mesg"),
	 N_("Go to next message"),
	 on_goto_next_mesg1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_N, GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL},
	{/*6*/
	 GNOME_APP_UI_ITEM, N_("_Go Back"),
	 N_("Go back"),
	 on_go_back_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_B, GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL},
	{/*7*/
	 GNOME_APP_UI_ITEM, N_("_Go Forward"),
	 N_("Go forward"),
	 on_go_forward_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_F, GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL},
	{/*8*/
	 GNOME_APP_UI_ITEM, N_("Tag Definition"),
	 N_("Goto tag definition"),
	 on_goto_tag_activate, (gpointer) TRUE, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_D, GDK_CONTROL_MASK, NULL},
	{/*9*/
	 GNOME_APP_UI_ITEM, N_("Tag Declaration"),
	 N_("Goto tag declaration"),
	 on_goto_tag_activate, (gpointer) FALSE, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_D, GDK_CONTROL_MASK | GDK_SHIFT_MASK, NULL},
	{/*10*/
	 GNOME_APP_UI_ITEM, N_("Next occurrence"),
	 N_("Find the next occurrence of current word"),
	 on_next_occur, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, GDK_CONTROL_MASK, NULL}, 
    {/*11*/
	 GNOME_APP_UI_ITEM, N_("Previous occurrence"),
	 N_("Find the previous occurrence of current word"),
	 on_prev_occur, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, GDK_CONTROL_MASK, NULL},
    
	GNOMEUIINFO_END/*12*/
};

#define	NUM_EDIT_SUBMENUS 17
static GnomeUIInfo edit1_menu_uiinfo[NUM_EDIT_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("U_ndo"),
	 N_("Undo the last action"),
	 on_editor_command_activate, (gpointer) ANE_UNDO, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_UNDO,
	 GDK_Z, GDK_CONTROL_MASK, NULL},

	{/*1*/
	 GNOME_APP_UI_ITEM, N_("_Redo"),
	 N_("Redo the last undone action"),
	 on_editor_command_activate, (gpointer) ANE_REDO, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_REDO,
	 GDK_R, GDK_CONTROL_MASK, NULL},

	 GNOMEUIINFO_SEPARATOR,/*2*/
	
	{/*3*/
	 GNOME_APP_UI_ITEM, N_("C_ut"),
	 N_("Cut the selected text from the editor to the clipboard"),
	 on_editor_command_activate, (gpointer) ANE_CUT, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CUT,
	 GDK_X, GDK_CONTROL_MASK, NULL},
	
	{/*4*/
	 GNOME_APP_UI_ITEM, N_("_Copy"),
	 N_("Copy the selected text to the clipboard"),
	 on_editor_command_activate, (gpointer) ANE_COPY, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_COPY,
	 GDK_C, GDK_CONTROL_MASK, NULL},
	
	{/*5*/
	 GNOME_APP_UI_ITEM, N_("_Paste"),
	 N_("Paste the content of clipboard at the current position"),
	 on_editor_command_activate, (gpointer) ANE_PASTE, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PASTE,
	 GDK_V, GDK_CONTROL_MASK, NULL},
	
	{/*6*/
	 GNOME_APP_UI_ITEM, N_("C_lear"),
	 N_("Delete the selected text from the editor"),
	 on_editor_command_activate, (gpointer) ANE_CLEAR, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_Delete, 0, NULL},
	
	GNOMEUIINFO_SEPARATOR,/*7*/
	
	{/*8*/
	 GNOME_APP_UI_SUBTREE, N_("_Transform"),
	 NULL,
	 transform1_submenu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	
	{/*9*/
	 GNOME_APP_UI_SUBTREE, N_("_Select"),
	 NULL,
	 select1_submenu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	
	{/*10*/
	 GNOME_APP_UI_SUBTREE, N_("_Insert text"),
	 NULL,
	 insert_submenu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	
	{/*11*/
	 GNOME_APP_UI_SUBTREE, N_("Co_mment code"),
	 NULL,
	 comment_submenu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
    {/*12*/
	 GNOME_APP_UI_SUBTREE, N_("_Search"),
	 NULL,
	 find_submenu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
    {/*13*/
	 GNOME_APP_UI_SUBTREE, N_("G_o to"),
	 NULL,
	 goto1_submenu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	
	GNOMEUIINFO_SEPARATOR,/*14*/
	
	{/*15*/
	 GNOME_APP_UI_ITEM, N_("_AutoComplete"),
	 N_("AutoComplete the current word"),
	 on_editor_command_activate, (gpointer) ANE_COMPLETEWORD, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_Return, GDK_CONTROL_MASK, NULL},

	{/*16*/
	 GNOME_APP_UI_ITEM, N_("S_how calltip"),
	 N_("Show calltip for the function"),
	 on_calltip1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	/*17*/
	GNOMEUIINFO_END
};

#define NUM_TOOLBAR_SUBMENUS 4
static GnomeUIInfo toolbar1_submenu_uiinfo[NUM_TOOLBAR_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_TOGGLEITEM, N_("_Main Toolbar"),
	 N_("Hide/Unhide Main toolbar"),
	 on_anjuta_toolbar_activate, ANJUTA_MAIN_TOOLBAR, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BLANK,
	 0, 0, NULL},
	{/*1*/
	 GNOME_APP_UI_TOGGLEITEM, N_("_Extended Toolbar"),
	 N_("Hide/Unhide Extended toolbar"),
	 on_anjuta_toolbar_activate, ANJUTA_EXTENDED_TOOLBAR, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*3*/
	 GNOME_APP_UI_TOGGLEITEM, N_("_Browser Toolbar"),
	 N_("Hide/Unhide Browser toolbar"),
	 on_anjuta_toolbar_activate, ANJUTA_BROWSER_TOOLBAR, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*4*/
	 GNOME_APP_UI_TOGGLEITEM, N_("_Format Toolbar"),
	 N_("Hide/Unhide Format toolbar"),
	 on_anjuta_toolbar_activate, ANJUTA_FORMAT_TOOLBAR, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_END/*5*/
};

#define NUM_EDITOR_SUBMENUS 7
static GnomeUIInfo editor1_submenu_uiinfo[NUM_EDITOR_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_TOGGLEITEM, N_("_Line numbers margin"),
	 N_("Show/Hide line numbers"),
	 on_editor_linenos1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BLANK,
	 0, 0, NULL},
	{/*1*/
	 GNOME_APP_UI_TOGGLEITEM, N_("_Markers Margin"),
	 N_("Show/Hide markers margin"),
	 on_editor_markers1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*2*/
	 GNOME_APP_UI_TOGGLEITEM, N_("_Code fold margin"),
	 N_("Show/Hide code fold margin"),
	 on_editor_codefold1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*3*/
	 GNOME_APP_UI_TOGGLEITEM, N_("_Indentation guides"),
	 N_("Show/Hide indentation guides"),
	 on_editor_indentguides1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*4*/
	 GNOME_APP_UI_TOGGLEITEM, N_("_White spaces"),
	 N_("Show/Hide white spaces"),
	 on_editor_whitespaces1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*5*/
	 GNOME_APP_UI_TOGGLEITEM, N_("_Line end characters"),
	 N_("Show/Hide line end characters"),
	 on_editor_eolchars1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*6*/
	 GNOME_APP_UI_TOGGLEITEM, N_("Line _wrapping"),
	 N_("Enable/disable line wrapping"),
	 on_editor_linewrap1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_END/*7*/
};

#define NUM_ZOOMTEXT_SUBMENUS 11
static GnomeUIInfo zoom_text1_submenu_uiinfo[NUM_ZOOMTEXT_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("++ Zoom"),
	 N_("Increase text zoom by 1 unit"),
	 on_zoom_text_activate, "++", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("+8"),
	 N_("Zoom factor +8"),
	 on_zoom_text_activate, "+8", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("+6"),
	 N_("Zoom factor +6"),
	 on_zoom_text_activate, "+6", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*3*/
	 GNOME_APP_UI_ITEM, N_("+4"),
	 N_("Zoom factor +4"),
	 on_zoom_text_activate, "+4", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*4*/
	 GNOME_APP_UI_ITEM, N_("+2"),
	 N_("Zoom factor +2"),
	 on_zoom_text_activate, "+2", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*5*/
	 GNOME_APP_UI_ITEM, N_("0"),
	 N_("Zoom factor 0"),
	 on_zoom_text_activate, "00", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*6*/
	 GNOME_APP_UI_ITEM, N_("-2"),
	 N_("Zoom factor -2"),
	 on_zoom_text_activate, "-2", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*7*/
	 GNOME_APP_UI_ITEM, N_("-4"),
	 N_("Zoom factor -4"),
	 on_zoom_text_activate, "-4", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*8*/
	 GNOME_APP_UI_ITEM, N_("-6"),
	 N_("Zoom factor -6"),
	 on_zoom_text_activate, "-6", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*9*/
	 GNOME_APP_UI_ITEM, N_("-8"),
	 N_("Zoom factor -8"),
	 on_zoom_text_activate, "-8", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*10*/
	 GNOME_APP_UI_ITEM, N_("-- Zoom"),
	 N_("Reduce text zoom by 1 unit"),
	 on_zoom_text_activate, "--", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_END/*11*/
};

#define	NUM_VIEW_SUBMENUS 7
static GnomeUIInfo view1_menu_uiinfo[NUM_VIEW_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("_Message window"),
	 N_("Show/Hide the Message window"),
	 on_messages1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ALIGN_LEFT,
	 GDK_F1, GDK_CONTROL_MASK, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("_Project window"),
	 N_("Show/Hide the Project window"),
	 on_project_listing1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ALIGN_LEFT,
	 GDK_F2, GDK_CONTROL_MASK, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("B_ookmarks"),
	 N_("Show the Bookmark window"),
	 on_bookmarks1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_F3, GDK_CONTROL_MASK, NULL},
	GNOMEUIINFO_SEPARATOR,/*3*/
	{/*4*/
	 GNOME_APP_UI_SUBTREE, N_("_Toolbars"),
	 NULL,
	 toolbar1_submenu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*5*/
	 GNOME_APP_UI_SUBTREE, N_("_Editor"),
	 NULL,
	 editor1_submenu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*6*/
	 GNOME_APP_UI_SUBTREE, N_("_Zoom text"),
	 NULL,
	 zoom_text1_submenu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_END/*18*/
};

#define NUM_IMPORTFILE_SUBMENUS 7
static GnomeUIInfo add_file1_menu_uiinfo[] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("Include file"),
	 NULL,
	 on_project_add_file1_activate, GINT_TO_POINTER(MODULE_INCLUDE + 1), NULL,
	 PIX_FILE(INCLUDE),
	 0, 0, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("Source file"),
	 NULL,
	 on_project_add_file1_activate, GINT_TO_POINTER(MODULE_SOURCE + 1), NULL,
	 PIX_FILE(SOURCE),
	 0, 0, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("Help file"),
	 NULL,
	 on_project_add_file1_activate, GINT_TO_POINTER(MODULE_HELP + 1), NULL,
	 PIX_FILE(HELP),
	 0, 0, NULL},
	{/*3*/
	 GNOME_APP_UI_ITEM, N_("Data file"),
	 NULL,
	 on_project_add_file1_activate, GINT_TO_POINTER(MODULE_DATA + 1), NULL,
	 PIX_FILE(DATA),
	 0, 0, NULL},
	{/*4*/
	 GNOME_APP_UI_ITEM, N_("Pixmap file"),
	 NULL,
	 on_project_add_file1_activate, GINT_TO_POINTER(MODULE_PIXMAP + 1), NULL,
	 PIX_FILE(PIXMAP),
	 0, 0, NULL},
	{/*5*/
	 GNOME_APP_UI_ITEM, N_("Translation file"),
	 NULL,
	 on_project_add_file1_activate, GINT_TO_POINTER(MODULE_PO + 1), NULL,
	 PIX_FILE(TRANSLATION),
	 0, 0, NULL},
	{/*6*/
	 GNOME_APP_UI_ITEM, N_("Doc file"),
	 NULL,
	 on_project_add_file1_activate, GINT_TO_POINTER(MODULE_DOC + 1), NULL,
	 PIX_FILE(DOC),
	 0, 0, NULL},
	GNOMEUIINFO_END /*7*/
};

#define NUM_PROJECT_SUBMENUS 14
static GnomeUIInfo project1_menu_uiinfo[NUM_PROJECT_SUBMENUS+1] = {
	{ /*0*/
	 GNOME_APP_UI_SUBTREE, N_("Add File"),
	 NULL,
	 add_file1_menu_uiinfo, NULL, NULL,
	 PIX_STOCK(NEW),
	 0, 0, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("Open in default viewer"),
	 NULL,
	 on_project_view1_activate, NULL, NULL,
	 PIX_STOCK(BOOK_OPEN),
	 0, 0, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("Open in Anjuta-TIa"),
	 NULL,
	 on_project_edit1_activate, NULL, NULL,
	 PIX_STOCK(OPEN),
	 0, 0, NULL},
	{/*3*/
	 GNOME_APP_UI_ITEM, N_("Remove File"),
	 NULL,
	 on_project_remove1_activate, NULL, NULL,
	 PIX_STOCK(CUT),
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR, /*4*/
	{/*5*/
	 GNOME_APP_UI_ITEM, N_("Configure Project"),
	 N_("Configure options for the current Project"),
	 on_project_configure1_activate, NULL, NULL,
	 PIX_STOCK(PREF),
	 0, 0, NULL},
	{/*6*/
	 GNOME_APP_UI_ITEM, N_("Project Info"),
	 N_("Display the Project information"),
	 on_project_project_info1_activate, NULL, NULL,
	 PIX_STOCK(PROP),
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR, /*7*/
	{/*8*/
	 GNOME_APP_UI_TOGGLEITEM, N_("Docked"),
	 N_("Dock/Undock the Project Window"),
	 on_project_dock_undock1_activate, NULL, NULL,
	 PIX_FILE(DOCK),
	 0, 0, NULL},
	 GNOMEUIINFO_SEPARATOR,/*9*/
	{/*10*/
	 GNOME_APP_UI_ITEM, N_("_Update tags image"),
	 N_("Update the tags image of the Project/opened files"),
	 on_update_tagmanager_activate, (gpointer) FALSE, NULL,
	 PIX_STOCK(FONT),
	 0, 0, NULL},
	{/*11*/
	 GNOME_APP_UI_ITEM, N_("Rebuild tags image"),
	 N_("Rebuild the tags image of the Project"),
	 on_update_tagmanager_activate, (gpointer) TRUE, NULL,
	 PIX_FILE(TAG),
	 0, 0, NULL},
	 GNOMEUIINFO_SEPARATOR,/*12*/
	{/*13*/
	 GNOME_APP_UI_ITEM, N_("Help"),
	 NULL,
	 on_project_help1_activate, NULL, NULL,
	 PIX_STOCK(BOOK_YELLOW),
	 0, 0, NULL},
	GNOMEUIINFO_END/*14*/
};

#define NUM_HILITE_SUBMENUS 5
static GnomeUIInfo hilitetype1_submenu_uiinfo[NUM_HILITE_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("Automatic"),
	 N_("Automatically determine the highlight style"),
	 on_force_hilite1_activate, GUINT_TO_POINTER (TE_LEXER_AUTOMATIC), NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXEC,
	 0, 0, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("No Highlight style"),
	 N_("Remove the current highlight style"),
	 on_force_hilite1_activate, GUINT_TO_POINTER (TE_LEXER_NONE), NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("C"),
	 N_("Force the highlight style to C"),
	 on_force_hilite1_activate, GUINT_TO_POINTER (TE_LEXER_CPP), NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*8*/
	 GNOME_APP_UI_ITEM, N_("Makefile"),
	 N_("Force the highlight style to Makefile"),
	 on_force_hilite1_activate, GUINT_TO_POINTER (TE_LEXER_MAKE), NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*20*/
	 GNOME_APP_UI_ITEM, N_("Prj/Properties"),
	 N_("Force the highlight style to project/properties files"),
	 on_force_hilite1_activate, GUINT_TO_POINTER (TE_LEXER_PROPS), NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_END/*27*/
};

#define NUM_FORMAT_SUBMENUS 11
static GnomeUIInfo format1_menu_uiinfo[NUM_FORMAT_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("Auto _Format"),
	 N_("Autoformat the current source file"),
	 on_indent1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ALIGN_LEFT,
	 0, 0, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("_Increase Indent"),
	 N_("Increase indentation of line/selection"),
	 on_editor_command_activate, (gpointer) ANE_INDENT_INCREASE, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("_Decrease Indent"),
	 N_("Decrease indentation of line/selection"),
	 on_editor_command_activate, (gpointer) ANE_INDENT_DECREASE, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*3*/
	{/*4*/
	 GNOME_APP_UI_SUBTREE, N_("Force _Highlight Style"),
	 NULL,
	 hilitetype1_submenu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*5*/
	{/*6*/
	 GNOME_APP_UI_ITEM, N_("_Close All Folds"),
	 N_("Close all code folds in the editor"),
	 on_editor_command_activate, (gpointer) ANE_CLOSE_FOLDALL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*7*/
	 GNOME_APP_UI_ITEM, N_("_Open All Folds"),
	 N_("Open all code folds in the editor"),
	 on_editor_command_activate, (gpointer) ANE_OPEN_FOLDALL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*8*/
	 GNOME_APP_UI_ITEM, N_("_Toggle Current Fold"),
	 N_("Toggle current code fold in the editor"),
	 on_editor_command_activate, (gpointer) ANE_TOGGLE_FOLD, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*9*/
	{/*10*/
	 GNOME_APP_UI_ITEM, N_("D_etach Current Document"),
	 N_("Detach the current document into a separate editor window"),
	 on_detach1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_END/*11*/
};

#define NUM_BUILD_SUBMENUS 18
static GnomeUIInfo build1_menu_uiinfo[NUM_BUILD_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("_Compile"),
	 N_("Compile the current source file"),
	 on_compile1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CONVERT,
	 GDK_F9, 0, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("Compile With _Make"),
	 N_("Compile the current source file using Make"),
	 on_make1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_F9, GDK_SHIFT_MASK, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("_Build"),
	 N_("Build the source directory of the Project or the current source file"),
	 on_build_project1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXEC,
	 GDK_F10, 0, NULL},
	{/*3*/
	 GNOME_APP_UI_ITEM, N_("Build _All"),
	 N_("Build the whole Project"),
	 on_build_all_project1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 GDK_F11, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*4*/
	{/*5*/
	 GNOME_APP_UI_ITEM, N_("Save Build Messages"),
	 N_("Save build messages to a file"),
	 on_save_build_messages_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*6*/
	{/*7*/
	 GNOME_APP_UI_ITEM, N_("Build _Distribution"),
	 N_("Build the distribution tarball of the Project"),
	 on_build_dist_project1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*8*/
	{/*10*/
	 GNOME_APP_UI_ITEM, N_("Auto _generate ..."),
	 N_("Auto generate all the build files for the Project"),
	 on_autogen_project1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*11*/
	{/*12*/
	 GNOME_APP_UI_ITEM, N_("Clea_n"),
	 N_("Clean the source directory"),
	 on_clean_project1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*13*/
	 GNOME_APP_UI_ITEM, N_("Clean A_ll"),
	 N_("Clean the whole Project directory"),
	 on_clean_all_project1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*14*/
	{/*15*/
	 GNOME_APP_UI_ITEM, N_("_Stop Build"),
	 N_("Stop the current compile or build process"),
	 on_stop_build_make1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_STOP,
	 GDK_F12, 0, NULL},
	GNOMEUIINFO_END/*19*/
};

#define NUM_BOOKMARK_SUBMENUS 8
static GnomeUIInfo bookmark1_menu_uiinfo[NUM_BOOKMARK_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("_Toggle bookmark"),
	 N_("Toggle a bookmark at the current line position"),
	 on_editor_command_activate, (gpointer) ANE_BOOKMARK_TOGGLE, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_INDEX,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*1*/
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("_First bookmark"),
	 N_("Jump to the first bookmark in the file"),
	 on_editor_command_activate, (gpointer) ANE_BOOKMARK_FIRST, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_TOP,
	 0, 0, NULL},
	{/*3*/
	 GNOME_APP_UI_ITEM, N_("_Previous bookmark"),
	 N_("Jump to the previous bookmark in the file"),
	 on_editor_command_activate, (gpointer) ANE_BOOKMARK_PREV, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_UP,
	 0, 0, NULL},
	{/*4*/
	 GNOME_APP_UI_ITEM, N_("_Next bookmark"),
	 N_("Jump to the next bookmark in the file"),
	 on_editor_command_activate, (gpointer) ANE_BOOKMARK_NEXT, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_DOWN,
	 0, 0, NULL},
	{/*5*/
	 GNOME_APP_UI_ITEM, N_("_Last bookmark"),
	 N_("Jump to the last bookmark in the file"),
	 on_editor_command_activate, (gpointer) ANE_BOOKMARK_LAST, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOTTOM,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*6*/
	{/*7*/
	 GNOME_APP_UI_ITEM, N_("_Clear all bookmarks"),
	 N_("Clear bookmarks"),
	 on_editor_command_activate, (gpointer) ANE_BOOKMARK_CLEAR, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CLOSE,
	 0, 0, NULL},
	GNOMEUIINFO_END/*8*/
};


#define NUM_CVS_SUBMENUS 16 
static GnomeUIInfo cvs_menu_uiinfo[NUM_CVS_SUBMENUS+1] = {
	{
	 /* 0 */
	 GNOME_APP_UI_ITEM, N_("U_pdate file"),
	 N_("Update current working copy"),
	 on_cvs_update_file_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_REFRESH,
	 0, 0, NULL},
	{
	 /* 1 */
	 GNOME_APP_UI_ITEM, N_("C_ommit file"),
	 N_("Commit changes to the repository"),
	 on_cvs_commit_file_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 2 */
	 GNOME_APP_UI_ITEM, N_("S_tatus of file"),
	 N_("Print the status of the current file"),
	 on_cvs_status_file_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 3 */
	 GNOME_APP_UI_ITEM, N_("G_et file log"),
	 N_("Print the CVS log for the current file"),
	 on_cvs_log_file_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 4 */
	 GNOME_APP_UI_ITEM, N_("_Add file"),
	 N_("Add the current file to the repository"),
	 on_cvs_add_file_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 5 */
	 GNOME_APP_UI_ITEM, N_("_Remove file"),
	 N_("Remove the current file from the repository"),
	 on_cvs_remove_file_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 6 */
	 GNOME_APP_UI_ITEM, N_("D_iff file"),
	 N_("Create a diff between the working copy and the repository"),
	 on_cvs_diff_file_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	 GNOMEUIINFO_SEPARATOR, /* 7 */
	{
	 /* 8 */
	 GNOME_APP_UI_ITEM, N_("_Update Project"),
	 N_("Update the working copy of a Project"),
	 on_cvs_update_project_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_REFRESH,
	 GDK_U, GDK_MOD1_MASK | GDK_CONTROL_MASK, NULL},
	{
	 /* 9 */
	 GNOME_APP_UI_ITEM, N_("_Commit Project"),
	 N_("Commit local changes to the repository"),
	 on_cvs_commit_project_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 10 */
	 GNOME_APP_UI_ITEM, N_("_Import Project"),
	 N_("Import Project as a new module in the repository"),
	 on_cvs_import_project_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	 {
	 /* 11 */
	 GNOME_APP_UI_ITEM, N_("_Status of Project"),
	 N_("Print the status of the Project"),
	 on_cvs_project_status_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	 {
	 /* 12 */
	 GNOME_APP_UI_ITEM, N_("Get Project _log"),
	 N_("Print the CVS log of the Project"),
	 on_cvs_project_log_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 /* 13 */
	 GNOME_APP_UI_ITEM, N_("_Diff Project"),
	 N_("Create a diff between the working copy of the Project and the repository"),
	 on_cvs_project_diff_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR, /* 14 */
	{
	 /* 15 */
	 GNOME_APP_UI_ITEM, N_("_Login"),
	 N_("Login to a CVS server"),
	 on_cvs_login_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	 /* 16 */
	 GNOMEUIINFO_END,
};

#define NUM_SETTINGS_SUBMENUS 10
static GnomeUIInfo settings1_menu_uiinfo[NUM_SETTINGS_SUBMENUS+1] = {
	{/*0*/
	 GNOME_APP_UI_ITEM, N_("_Compiler and Linker Settings ..."),
	 N_("Settings for the compiler and linker"),
	 on_set_compiler1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PREF,
	 0, 0, NULL},
	{/*1*/
	 GNOME_APP_UI_ITEM, N_("_Source Paths ..."),
	 N_("Specify the source paths for Anjuta-TIa to search"),
	 on_set_src_paths1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PREF,
	 0, 0, NULL},
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("Co_mmands ..."),
	 N_("Specify the various commands for use"),
	 on_set_commands1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PREF,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*3*/
	{/*4*/
	 GNOME_APP_UI_ITEM, N_("_Preferences ..."),
	 N_("Do you prefer coffee to tea? Check it out."),
	 on_set_preferences1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PROP,
	 0, 0, NULL},
	{/*5*/
	 GNOME_APP_UI_ITEM, N_("_Edit user.properties file ..."),
	 N_("Edit user properties file"),
	 on_edit_user_properties1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PROP,
	 0, 0, NULL},
	{/*6*/
	 GNOME_APP_UI_ITEM, N_("Set _Default Preferences"),
	 N_("But I prefer tea."),
	 on_set_default_preferences1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PROP,
	 0, 0, NULL},
	{/*7*/
	 GNOME_APP_UI_ITEM, N_("C_ustomize shortcuts"),
	 N_("Customize shortcuts associated with menu items"),
	 on_customize_shortcuts_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*8*/
	 GNOME_APP_UI_ITEM, N_("_Tools Editor"),
	 N_("Customize user-defined tools"),
	 on_tool_editor_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	 {/*9*/
	 GNOME_APP_UI_ITEM, N_("_First Run Dialog"),
	 N_("Run the first-run dialog"),
	 on_first_run_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	 GNOMEUIINFO_END,/*10*/
};

#define NUM_HELP_SUBMENUS 18
static GnomeUIInfo help1_menu_uiinfo[NUM_HELP_SUBMENUS+1] = {
	GNOMEUIINFO_HELP ("anjuta"),/*0*/
	GNOMEUIINFO_SEPARATOR,/*1*/
	{/*2*/
	 GNOME_APP_UI_ITEM, N_("Browse TIGCC library _API Pages"),
	 N_("The TIGCC library API pages"),
	 on_gnome_pages1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_RED,
	 GDK_F1, 0, NULL},
	{/*3*/
	 GNOME_APP_UI_ITEM, N_("Browse _Man Pages"),
	 N_("The good old manual pages"),
	 on_url_activate, "man:man", NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_RED,
	 0, 0, NULL},
	{/*4*/
	 GNOME_APP_UI_ITEM, N_("Browse _Info Pages"),
	 N_("Browse Info pages"),
	 on_url_activate, "info:info", NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_RED,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*5*/
	{/*6*/
	 GNOME_APP_UI_ITEM, N_("_Context Help"),
	 N_("Search help for the current word in the editor"),
	 on_context_help_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SEARCH,
 	 GDK_H, GDK_CONTROL_MASK, NULL},
	{/*7*/
	 GNOME_APP_UI_ITEM, N_("_Search a topic"),
	 N_("May I help you?"),
	 on_search_a_topic1_activate, NULL, NULL,
	 GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SEARCH,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*8*/
	{/*9*/
	 GNOME_APP_UI_ITEM, N_("Anjuta-TIa _Home Page"),
	 N_("Online documentation and resources"),
	 on_url_activate, "http://yabdeo.free.fr", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*10*/
	{/*11*/
	 GNOME_APP_UI_ITEM, N_("_Libraries API references"),
	 N_("TIGCC online reference library"),
	 on_url_activate, "http://tigcc.ticalc.org", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*12*/
	 GNOME_APP_UI_ITEM, N_("Report _Bugs"),
	 N_("Submit a bug report for Anjuta-TIa"),
	 on_url_activate, "http://", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*13*/
	 GNOME_APP_UI_ITEM, N_("Request _Features"),
	 N_("Submit a feature request for Anjuta-TIa"),
	 on_url_activate, "http://", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*14*/
	 GNOME_APP_UI_ITEM, N_("Submit _patches"),
	 N_("Submit patches for Anjuta-TIa"),
	 on_url_activate, "http://", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{/*15*/
	 GNOME_APP_UI_ITEM, N_("Ask a _question"),
	 N_("Submit a question for FAQs"),
	 on_url_activate, "mailto:stephane.akhoun@laposte.net", NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_SEPARATOR,/*16*/
	GNOMEUIINFO_MENU_ABOUT_ITEM (on_about1_activate, NULL),/*17*/
	GNOMEUIINFO_END/*18*/
};

#define NUM_TOPLEVEL_SUBMENUS 10
static GnomeUIInfo menubar1_uiinfo[] = {
	GNOMEUIINFO_MENU_FILE_TREE (file1_menu_uiinfo),
	GNOMEUIINFO_MENU_EDIT_TREE (edit1_menu_uiinfo),
	GNOMEUIINFO_MENU_VIEW_TREE (view1_menu_uiinfo),
	{
	 GNOME_APP_UI_SUBTREE, N_("_Project"),
	 NULL,
	 project1_menu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 GNOME_APP_UI_SUBTREE, N_("For_mat"),
	 NULL,
	 format1_menu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 GNOME_APP_UI_SUBTREE, N_("_Build"),
	 NULL,
	 build1_menu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 GNOME_APP_UI_SUBTREE, N_("Bookmar_k"),
	 NULL,
	 bookmark1_menu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 GNOME_APP_UI_SUBTREE, N_("_CVS"),
	 NULL,
	 cvs_menu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	{
	 GNOME_APP_UI_SUBTREE, N_("_Settings"),
	 NULL,
	 settings1_menu_uiinfo, NULL, NULL,
	 GNOME_APP_PIXMAP_NONE, NULL,
	 0, 0, NULL},
	GNOMEUIINFO_MENU_HELP_TREE (help1_menu_uiinfo),
	GNOMEUIINFO_END
};

/* Add new submenu structure pointers defined above here
 * which require ref and unref done, except Help submenus.
 * Help submenu is taken care separatedly.
 */
static GnomeUIInfo* anjuta_menus_uiinfo[] = {
	menubar1_uiinfo,
	file1_menu_uiinfo,
	transform1_submenu_uiinfo,
	select1_submenu_uiinfo,
	comment_submenu_uiinfo,
	find_submenu_uiinfo,
	goto1_submenu_uiinfo,
	insert_template_c_uiinfo,
	inserttext1_submenu_uiinfo,
	insert_submenu_uiinfo,
	edit1_menu_uiinfo,
	toolbar1_submenu_uiinfo,
	editor1_submenu_uiinfo,
	view1_menu_uiinfo,
	zoom_text1_submenu_uiinfo,
	add_file1_menu_uiinfo,
	project1_menu_uiinfo,
	hilitetype1_submenu_uiinfo,
	format1_menu_uiinfo,
	build1_menu_uiinfo,
	bookmark1_menu_uiinfo,
	settings1_menu_uiinfo,
};

#endif
